From 0c7a3af1f3bf9d1604eeda58ca38005420a6e763 Mon Sep 17 00:00:00 2001
From: Parth Patel <parthamrutbhai.patel@sjsu.edu>
Date: Tue, 8 Mar 2022 16:38:20 -0800
Subject: [PATCH 1/2] Fixes Issue 241, Emoji Picker addition to Messages
 activity, a=chris

---
 src/css/messages.css                       |  147 +-
 src/views/elements/UsermessagesElement.php |   93 +-
 src/views/helpers/EmojipickerHelper.php    | 2002 ++++++++++++++++++++
 3 files changed, 2230 insertions(+), 12 deletions(-)
 create mode 100644 src/views/helpers/EmojipickerHelper.php

diff --git a/src/views/elements/UsermessagesElement.php b/src/views/elements/UsermessagesElement.php
index 558cea6a4..cdb60afea 100644
--- a/src/views/elements/UsermessagesElement.php
+++ b/src/views/elements/UsermessagesElement.php
@@ -42,6 +42,11 @@ use seekquarry\yioop\library\CrawlConstants;
  */
 class UsermessagesElement extends Element implements CrawlConstants
 {
+    /**
+     * Emojipicker helper
+     * @var helper
+     */
+    public $emoji_helper;
     /**
      *
      *
@@ -56,6 +61,7 @@ class UsermessagesElement extends Element implements CrawlConstants
             }
             return;
         }
+        $this->emoji_helper = $this->view->helper('emojipicker');
         ?>
         <div class="messages-container"><?php
         if ($is_mobile && empty($data['CONTACT_ID']) || !$is_mobile) { ?>
@@ -110,7 +116,7 @@ class UsermessagesElement extends Element implements CrawlConstants
         </form>
         <?php
         $token_string = C\CSRF_TOKEN . "=". $data[C\CSRF_TOKEN];
-        foreach($data['CONTACTS'] as $contact_id => $contact_info) {
+        foreach ($data['CONTACTS'] as $contact_id => $contact_info) {
             $selected = ($contact_id == $data['CONTACT_ID']) ?
                 " selected-contact " : "";
             ?>
@@ -136,7 +142,7 @@ class UsermessagesElement extends Element implements CrawlConstants
                 "blockcontact" => tl('usermessages_element_block'),
                 "ignorecontact" => tl('usermessages_element_ignore'),
             ];
-            foreach($data['CONTACT_REQUESTS'] as $contact_id => $contact_info) {
+            foreach ($data['CONTACT_REQUESTS'] as $contact_id => $contact_info) {
                 $contact_request_url = B\feedsUrl('user_messages',
                     $contact_id, true, $data['CONTROLLER']) .
                     $token_string . "&amp;contact_id=$contact_id&amp;arg=";
@@ -277,7 +283,7 @@ class UsermessagesElement extends Element implements CrawlConstants
         ?>
         <div class="new-message-container">
         <form  id="newmessageForm" method="post" action="<?=C\SHORT_BASE_URL?>"
-            enctype='multipart/form-data'>
+            enctype='multipart/form-data' onsubmit="parseEmojiShortcuts()">
         <input type="hidden" name="c" value="<?=$data['CONTROLLER'] ?>" />
         <input type="hidden" name="a" value="userMessages" />
         <input type="hidden" name="arg" value="newmessage" />
@@ -290,9 +296,15 @@ class UsermessagesElement extends Element implements CrawlConstants
         <a id="attach-new-file"
             href="javascript:elt('file-new-message').click()"
             >📎</a>
-        <input type="ext" id="new-message"  name="description"
-            placeholder="<?=tl('usermessages_element_new_message') ?>"
-             />
+        <span id="user-input-container">
+            <button id="emoji-picker-button" type="button"
+                onclick="toggleEmojiPicker()">🙂</button>
+            <div class="emoji-picker-container" id="emoji-picker-container">
+                <?=$this->emoji_helper->render();?>
+            </div>
+            <input type="ext" id="new-message"  name="description"
+                placeholder="<?=tl('usermessages_element_new_message') ?>" />
+        </span>
         <button type="submit" id="send-message" ><?=$arrow ?></button>
         </form>
         </div>
@@ -306,8 +318,75 @@ class UsermessagesElement extends Element implements CrawlConstants
               L\metricToInt(ini_get('post_max_size')))
               ?>, "textarea", null, true);
         }
+        const emoji_groups = <?php echo
+            json_encode($this->emoji_helper->emoji_groups); ?>;
+        let emojis_array = {};
+        for (const group in emoji_groups) {
+            let group_data = emoji_groups[group];
+            for (const emoji in group_data["emojis"]) {
+                emojis_array[emoji] = group_data["emojis"][emoji][0];
+            }
+        }
+        function insertEmoji(emoji)
+        {
+            let input = document.getElementById('new-message');
+            input.value += emoji;
+        }
+        function toggleEmojiPicker()
+        {
+            let emoji_picker =
+                document.getElementById('emoji-picker-container');
+            if (emoji_picker.style.display === "none"
+                || emoji_picker.style.display === "") {
+                emoji_picker.style.display = "inline-block";
+            } else {
+                emoji_picker.style.display = "none";
+            }
+        }
+        function toggleEmojiGroup(emoji_grp_tab, emoji_grp_name)
+        {
+            let emoji_grp_id = "emoji-group-" + emoji_grp_name;
+            let emoji_groups =
+                document.getElementsByClassName("emoji-group-container");
+            for (let i=0;i<emoji_groups.length;i++) {
+                if (emoji_groups[i].id === emoji_grp_id) {
+                    emoji_groups[i].className += " active-emoji-group";
+                } else {
+                    emoji_groups[i].className = "emoji-group-container";
+                }
+            }
+            let emoji_grps_tab =
+                document.getElementsByClassName("emoji-group-tab");
+            for (let i=0;i<emoji_grps_tab.length;i++) {
+                emoji_grps_tab[i].className = "emoji-group-tab";
+            }
+            emoji_grp_tab.className += " active-emoji-group-tab";
+        }
+        function parseEmojiShortcuts()
+        {
+            let input = document.getElementById("new-message");
+            let raw_message = input.value;
+            let possible_shortcuts = raw_message.matchAll(/\[([^\]]+)\]/g);
+            let parse_message = "";
+            let last_start_idx = 0;
+            for (let shortcut of possible_shortcuts) {
+                let text = shortcut[1];
+                let emoji = emojis_array[text];
+                if (emoji !== undefined) {
+                    parse_message += raw_message.substring(last_start_idx,
+                        shortcut["index"]) + emoji;
+                } else {
+                    parse_message += raw_message.substring(last_start_idx,
+                        shortcut["index"]) + "[" + text + "]";
+                }
+                last_start_idx = shortcut["index"] + text.length + 2;
+            }
+            parse_message += raw_message.substring(last_start_idx);
+            input.value = parse_message;
+            return true;
+        }
         </script>
         </div><?php
     }
 
-}
+}
\ No newline at end of file
